--------------------------------------------------------------------------------
-- Company: 
-- Engineer:	JK
--
-- Create Date:    11:37:12 05/22/05
-- Design Name:    
-- Module Name:    switch - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity switch is
    Port ( clk : in std_logic;
           reset : in std_logic;
           switcha : in std_logic;
           switchb : in std_logic;
           direction : out std_logic);
end switch;

architecture Behavioral of switch is

signal 	switcha_sync, switcha_int,
		 	switchb_sync, switchb_int,
			re_switcha, fe_switcha,
			re_switchb, fe_switchb,
			direction_state,direction_state_next	 : std_logic;
begin

sync: process(clk,reset)
begin
	if (reset='1') then
		switcha_sync<='0'; switcha_int<='0';
		switchb_sync<='0'; switchb_int<='0';
	elsif rising_edge(clk) then
		switcha_sync<=switcha;
		switchb_sync<=switchb;
		switcha_int<=switcha_sync;
		switchb_int<=switchb_sync;
	end if;
end process;

re_switchb<='1' when switchb_int='0' and switchb_sync='1' else '0';
fe_switchb<='1' when switchb_int='1' and switchb_sync='0' else '0';

output_seq: process (clk,reset)
begin
	if (reset='1') then
		direction_state<='0';
	elsif rising_edge(clk) then
		direction_state<=direction_state_next;
	end if;
end process;

output_com: process (switcha_int,re_switchb,fe_switchb,direction_state)
begin
	--default statement
	direction_state_next<=direction_state;

	if (re_switchb='1') then
		if (switcha_int='1') then
			direction_state_next<='0';
		else
			direction_state_next<='1';
		end if;
	end if;
	
	if (fe_switchb='1') then
		if (switcha_int='1') then
			direction_state_next<='0';
		else
			direction_state_next<='1';
		end if;
	end if;	
end process;

direction<=direction_state;


end Behavioral;
